
/*******************************************************************************
// GY-85 ITG-3205 IICԳ
// ʹõƬSTM32F103C8T6
// 8.00M
// 뻷 Keil uVision4
// ʱ䣺201191
// ģ GPIOB6->SCL GPIOB7->SDA      
// ʹãSTM32F103C8T61ӵ
// Դʾʣ115200
// QQ531389319
*******************************************************************************/

#include "stm32f10x_lib.h"
#include  <math.h>    //Keil library  

GPIO_InitTypeDef GPIO_InitStructure;
ErrorStatus HSEStartUpStatus;

#define   uchar unsigned char
#define   uint unsigned int	

//ITG3205ڲַ********************
#define WHO	    0x00
#define	SMPL	0x15
#define DLPF	0x16
#define INT_C	0x17
#define INT_S	0x1A
#define	TMP_H	0x1B
#define	TMP_L	0x1C
#define	GX_H	0x1D
#define	GX_L	0x1E
#define	GY_H	0x1F
#define	GY_L	0x20
#define GZ_H	0x21
#define GZ_L	0x22
#define PWR_M	0x3E
//****************************

#define	ITG3205_Addr   0xD0	  //IICеĴӵַ,ALT  ADDRESSַŲͬ޸

unsigned char TX_DATA[4];  	 //ʾݻ
unsigned char BUF[10];       //ݻ
char  test=0; 				 //IICõ
short T_X,T_Y,T_Z,T_T;		 //X,Y,Zᣬ¶

//************************************
/*ģIIC˿붨*/
#define SCL_H         GPIOB->BSRR = GPIO_Pin_6
#define SCL_L         GPIOB->BRR  = GPIO_Pin_6 
   
#define SDA_H         GPIOB->BSRR = GPIO_Pin_7
#define SDA_L         GPIOB->BRR  = GPIO_Pin_7

#define SCL_read      GPIOB->IDR  & GPIO_Pin_6
#define SDA_read      GPIOB->IDR  & GPIO_Pin_7

/*  -----------------------------------------------*/
void RCC_Configuration(void);
void GPIO_Configuration(void);
void NVIC_Configuration(void);
void USART1_Configuration(void);
void WWDG_Configuration(void);
void Delay(u32 nTime);
void Delayms(vu32 m);  
/*  ----------------------------------------------*/

  /*******************************/
void DATA_printf(uchar *s,short temp_data)
{
	if(temp_data<0){
	temp_data=-temp_data;
    *s='-';
	}
	else *s=' ';
    *++s =temp_data/100+0x30;
    temp_data=temp_data%100;     //ȡ
    *++s =temp_data/10+0x30;
    temp_data=temp_data%10;      //ȡ
    *++s =temp_data+0x30; 	
}

/*******************************************************************************
* Function Name  : I2C_GPIO_Config
* Description    : Configration Simulation IIC GPIO
* Input          : None 
* Output         : None
* Return         : None
****************************************************************************** */
void I2C_GPIO_Config(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure; 
 
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_6;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;  
  GPIO_Init(GPIOB, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_7;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;
  GPIO_Init(GPIOB, &GPIO_InitStructure);
}

/*******************************************************************************
* Function Name  : I2C_delay
* Description    : Simulation IIC Timing series delay
* Input          : None
* Output         : None
* Return         : None
****************************************************************************** */
void I2C_delay(void)
{
		
   u8 i=30; //Żٶ	͵5д
   while(i) 
   { 
     i--; 
   }  
}

void delay5ms(void)
{
		
   int i=5000;  
   while(i) 
   { 
     i--; 
   }  
}
/*******************************************************************************
* Function Name  : I2C_Start
* Description    : Master Start Simulation IIC Communication
* Input          : None
* Output         : None
* Return         : Wheather	 Start
****************************************************************************** */
bool I2C_Start(void)
{
	SDA_H;
	SCL_H;
	I2C_delay();
	if(!SDA_read)return FALSE;	//SDAΪ͵ƽæ,˳
	SDA_L;
	I2C_delay();
	if(SDA_read) return FALSE;	//SDAΪߵƽ߳,˳
	SDA_L;
	I2C_delay();
	return TRUE;
}
/*******************************************************************************
* Function Name  : I2C_Stop
* Description    : Master Stop Simulation IIC Communication
* Input          : None
* Output         : None
* Return         : None
****************************************************************************** */
void I2C_Stop(void)
{
	SCL_L;
	I2C_delay();
	SDA_L;
	I2C_delay();
	SCL_H;
	I2C_delay();
	SDA_H;
	I2C_delay();
} 
/*******************************************************************************
* Function Name  : I2C_Ack
* Description    : Master Send Acknowledge Single
* Input          : None
* Output         : None
* Return         : None
****************************************************************************** */
void I2C_Ack(void)
{	
	SCL_L;
	I2C_delay();
	SDA_L;
	I2C_delay();
	SCL_H;
	I2C_delay();
	SCL_L;
	I2C_delay();
}   
/*******************************************************************************
* Function Name  : I2C_NoAck
* Description    : Master Send No Acknowledge Single
* Input          : None
* Output         : None
* Return         : None
****************************************************************************** */
void I2C_NoAck(void)
{	
	SCL_L;
	I2C_delay();
	SDA_H;
	I2C_delay();
	SCL_H;
	I2C_delay();
	SCL_L;
	I2C_delay();
} 
/*******************************************************************************
* Function Name  : I2C_WaitAck
* Description    : Master Reserive Slave Acknowledge Single
* Input          : None
* Output         : None
* Return         : Wheather	 Reserive Slave Acknowledge Single
****************************************************************************** */
bool I2C_WaitAck(void) 	 //Ϊ:=1ACK,=0ACK
{
	SCL_L;
	I2C_delay();
	SDA_H;			
	I2C_delay();
	SCL_H;
	I2C_delay();
	if(SDA_read)
	{
      SCL_L;
	  I2C_delay();
      return FALSE;
	}
	SCL_L;
	I2C_delay();
	return TRUE;
}
/*******************************************************************************
* Function Name  : I2C_SendByte
* Description    : Master Send a Byte to Slave
* Input          : Will Send Date
* Output         : None
* Return         : None
****************************************************************************** */
void I2C_SendByte(u8 SendByte) //ݴӸλλ//
{
    u8 i=8;
    while(i--)
    {
        SCL_L;
        I2C_delay();
      if(SendByte&0x80)
        SDA_H;  
      else 
        SDA_L;   
        SendByte<<=1;
        I2C_delay();
		SCL_H;
        I2C_delay();
    }
    SCL_L;
}  
/*******************************************************************************
* Function Name  : I2C_RadeByte
* Description    : Master Reserive a Byte From Slave
* Input          : None
* Output         : None
* Return         : Date From Slave 
****************************************************************************** */
unsigned char I2C_RadeByte(void)  //ݴӸλλ//
{ 
    u8 i=8;
    u8 ReceiveByte=0;

    SDA_H;				
    while(i--)
    {
      ReceiveByte<<=1;      
      SCL_L;
      I2C_delay();
	  SCL_H;
      I2C_delay();	
      if(SDA_read)
      {
        ReceiveByte|=0x01;
      }
    }
    SCL_L;
    return ReceiveByte;
} 
//ZRX          
//ֽд*******************************************

bool Single_Write(unsigned char SlaveAddress,unsigned char REG_Address,unsigned char REG_data)		     //void
{
  	if(!I2C_Start())return FALSE;
    I2C_SendByte(SlaveAddress);   //豸ַ+дź//I2C_SendByte(((REG_Address & 0x0700) >>7) | SlaveAddress & 0xFFFE);//øʼַ+ַ 
    if(!I2C_WaitAck()){I2C_Stop(); return FALSE;}
    I2C_SendByte(REG_Address );   //õʼַ      
    I2C_WaitAck();	
    I2C_SendByte(REG_data);
    I2C_WaitAck();   
    I2C_Stop(); 
    delay5ms();
    return TRUE;
}

//ֽڶȡ*****************************************
unsigned char Single_Read(unsigned char SlaveAddress,unsigned char REG_Address)
{   unsigned char REG_data;     	
	if(!I2C_Start())return FALSE;
    I2C_SendByte(SlaveAddress); //I2C_SendByte(((REG_Address & 0x0700) >>7) | REG_Address & 0xFFFE);//øʼַ+ַ 
    if(!I2C_WaitAck()){I2C_Stop();test=1; return FALSE;}
    I2C_SendByte((u8) REG_Address);   //õʼַ      
    I2C_WaitAck();
    I2C_Start();
    I2C_SendByte(SlaveAddress+1);
    I2C_WaitAck();

	REG_data= I2C_RadeByte();
    I2C_NoAck();
    I2C_Stop();
    //return TRUE;
	return REG_data;

}						      

/*
********************************************************************************
**   RCC_Configuration(void)
**   ʱӳʼ
**     	 
**     	 
**     	 
********************************************************************************
*/
void RCC_Configuration(void)
{   
  /* RCC system reset(for debug purpose) */
  RCC_DeInit();

  /* Enable HSE */
  RCC_HSEConfig(RCC_HSE_ON);

  /* Wait till HSE is ready */
  HSEStartUpStatus = RCC_WaitForHSEStartUp();

  if(HSEStartUpStatus == SUCCESS)
  {
    /* HCLK = SYSCLK */
    RCC_HCLKConfig(RCC_SYSCLK_Div1); 
  
    /* PCLK2 = HCLK */
    RCC_PCLK2Config(RCC_HCLK_Div1); 

    /* PCLK1 = HCLK/2 */
    RCC_PCLK1Config(RCC_HCLK_Div2);

    /* Flash 2 wait state */
    FLASH_SetLatency(FLASH_Latency_2);
    /* Enable Prefetch Buffer */
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);

    /* PLLCLK = 8MHz * 9 = 72 MHz */
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);

    /* Enable PLL */ 
    RCC_PLLCmd(ENABLE);

    /* Wait till PLL is ready */
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET)
    {
    }

    /* Select PLL as system clock source */
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);

    /* Wait till PLL is used as system clock source */
    while(RCC_GetSYSCLKSource() != 0x08)
    {
    }
  } 
   /* Enable GPIOA, GPIOB, GPIOC, GPIOD, GPIOE, GPIOF, GPIOG and AFIO clocks */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB , ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC | RCC_APB2Periph_GPIOD , ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOE | RCC_APB2Periph_GPIOF , ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOG | RCC_APB2Periph_AFIO  , ENABLE);  
}

/*
********************************************************************************
**   GPIO_Configuration(void)
**   ˿ڳʼ
**     	 
**     	 
**     	 
********************************************************************************
*/
void GPIO_Configuration(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;
  RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC | RCC_APB2Periph_GPIOD, ENABLE  );
   /* Configure USART1 Tx (PA.09) as alternate function push-pull */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;				 //	ѡйܽ9
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;		 // 
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		 // 50MHz
  GPIO_Init(GPIOA, &GPIO_InitStructure);				 // ѡA˿
    
  /* Configure USART1 Rx (PA.10) as input floating */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;			  //ѡйܽ10
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;	  //
  GPIO_Init(GPIOA, &GPIO_InitStructure);				  //ѡA˿

}

/*
********************************************************************************
**   USART1_Configuration(void)
**   1ʼ
**     	 
**     	 
**     	 
********************************************************************************
*/
void USART1_Configuration(void)
{

USART_InitTypeDef USART_InitStructure;
USART_ClockInitTypeDef  USART_ClockInitStructure;

RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1 |RCC_APB2Periph_USART1, ENABLE  );

USART_ClockInitStructure.USART_Clock = USART_Clock_Disable;			// ʱӵ͵ƽ
USART_ClockInitStructure.USART_CPOL = USART_CPOL_Low;				// ʱӵ͵ƽ
USART_ClockInitStructure.USART_CPHA = USART_CPHA_2Edge;				// ʱӵڶؽݲ
USART_ClockInitStructure.USART_LastBit = USART_LastBit_Disable;		// һλݵʱ岻SCLK
/* Configure the USART1 synchronous paramters */
USART_ClockInit(USART1, &USART_ClockInitStructure);					// ʱӲʼ
																	 
USART_InitStructure.USART_BaudRate = 115200;						  // Ϊ115200
USART_InitStructure.USART_WordLength = USART_WordLength_8b;			  // 8λ
USART_InitStructure.USART_StopBits = USART_StopBits_1;				  // ֡β1ֹͣλ
USART_InitStructure.USART_Parity = USART_Parity_No ;				  // żʧ
USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;	// Ӳʧ

USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;		  // ʹ+ʹ
/* Configure USART1 basic and asynchronous paramters */
USART_Init(USART1, &USART_InitStructure);
    
  /* Enable USART1 */
USART_ClearFlag(USART1, USART_IT_RXNE); 			//жϣһжϺж
USART_ITConfig(USART1,USART_IT_RXNE, ENABLE);		//ʹUSART1жԴ
USART_Cmd(USART1, ENABLE);							//USART1ܿأ 
}


/*
********************************************************************************
**   NVIC_Configuration(void)
**   жϳʼ
**     	 
**     	 
**     	 
********************************************************************************
*/
void NVIC_Configuration(void)
{ 
  NVIC_InitTypeDef NVIC_InitStructure;  
  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0); 
 
  NVIC_InitStructure.NVIC_IRQChannel = WWDG_IRQChannel;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_Init(&NVIC_InitStructure);

}

 /*
********************************************************************************
**   WWDG_Configuration(void)
**   Źʼ
**     	 
**     	 
**     	 
********************************************************************************
*/
void WWDG_Configuration(void)
{
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_WWDG, ENABLE);	
  WWDG_SetPrescaler(WWDG_Prescaler_8);	              //  WWDG clock counter = (PCLK1/4096)/8 = 244 Hz (~4 ms)  
  WWDG_SetWindowValue(0x41);		                 // Set Window value to 0x41
  WWDG_Enable(0x50);		       // Enable WWDG and set counter value to 0x7F, WWDG timeout = ~4 ms * 64 = 262 ms 
  WWDG_ClearFlag();			       // Clear EWI flag
  WWDG_EnableIT();			       // Enable EW interrupt
}

/*
********************************************************************************
**   Delay(vu32 nCount)
**   ʱ
**     	 
**     	 
**     	 
********************************************************************************
*/
 void Delay(vu32 nCount)
{
  for(; nCount != 0; nCount--);
}

/*
********************************************************************************
**   void Delayms(vu32 m)
**   ʱ	 m=1,ʱ1ms
**     	 
**     	 
**     	 
********************************************************************************
*/
 void Delayms(vu32 m)
{
  u32 i;
  
  for(; m != 0; m--)	
       for (i=0; i<50000; i++);
}

/*
********************************************************************************
**   WWDG_IRQHandler(void)
**   ǰж
**     	 
**     	 
**     	 
********************************************************************************
*/ 

void WWDG_IRQHandler(void)
{
  /* Update WWDG counter */
  WWDG_SetCounter(0x50);
	
  /* Clear EWI flag */
  WWDG_ClearFlag(); 
}
 //************************************************
void  USART1_SendData(uchar SendData)
{
USART_SendData(USART1, SendData);
Delayms(1);
}
//ʼITG3205Ҫοpdf޸************************
void Init_ITG3205(void)
{
   Single_Write(ITG3205_Addr,PWR_M, 0x80);   //
   Single_Write(ITG3205_Addr,SMPL, 0x07);    //
   Single_Write(ITG3205_Addr,DLPF, 0x1E);    //2000
   Single_Write(ITG3205_Addr,INT_C, 0x00 );  //
   Single_Write(ITG3205_Addr,PWR_M, 0x00);   //
}
	
//******ȡITG3205****************************************
void READ_ITG3205(void)
{
   BUF[0]=Single_Read(ITG3205_Addr,GX_L); 
   BUF[1]=Single_Read(ITG3205_Addr,GX_H);
   T_X=	(BUF[1]<<8)|BUF[0];
   T_X/=14.375; 						   //ȡX

   BUF[2]=Single_Read(ITG3205_Addr,GY_L);
   BUF[3]=Single_Read(ITG3205_Addr,GY_H);
   T_Y=	(BUF[3]<<8)|BUF[2];
   T_Y/=14.375; 						   //ȡY
   BUF[4]=Single_Read(ITG3205_Addr,GZ_L);
   BUF[5]=Single_Read(ITG3205_Addr,GZ_H);
   T_Z=	(BUF[5]<<8)|BUF[4];
   T_Z/=14.375; 					       //ȡZ

   BUF[6]=Single_Read(ITG3205_Addr,TMP_L); 
   BUF[7]=Single_Read(ITG3205_Addr,TMP_H); 
   T_T=(BUF[7]<<8)|BUF[6];
   T_T = 35+ ((double) (T_T + 13200)) / 280;// ȡ¶
}
 //********ڷ***************************************
 void Send_data(uchar axis)
 {uchar i;
  USART1_SendData(axis);
  USART1_SendData(':');
  for(i=0;i<4;i++)USART1_SendData(TX_DATA[i]);
  USART1_SendData(' ');
  USART1_SendData(' ');
 }

  /*
********************************************************************************
**   main(void)
**   
**     	 
**     	 
**     	 
********************************************************************************
*/
int main(void)
{ 
  RCC_Configuration();		 //RCC
  GPIO_Configuration();		 //GPIO
  USART1_Configuration();	 //ô1
  I2C_GPIO_Config();		 //IICʹö˿
  Delayms(10);				 //ʱ
  Init_ITG3205();		     //ʼITG3205
  while(1)
 {
	READ_ITG3205();	         //ȡITG3205
    DATA_printf(TX_DATA,T_X);//תXݵ
	Send_data('X');			 //X
	DATA_printf(TX_DATA,T_Y);//תYݵ
	Send_data('Y');			 //Y
	DATA_printf(TX_DATA,T_Z);//תZݵ
	Send_data('Z');			 //Z
	DATA_printf(TX_DATA,T_T);//ת¶ݵ
	Send_data('T');			 //¶
	USART1_SendData(0X0D);	 //
	USART1_SendData(0X0A);	 //س
	Delayms(5);				 //ʱ
  }
}

/****************************/
